<!DOCTYPE html>
<html lang="en">
<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.3.0/css/all.min.css" >
</head>
<body>

<div class="container">
  <h2 style="text-align: center;">Danh sách Các Khóa Học</h2>
  <button  class='btn btn-success course-add'><i class="fa-solid fa-plus"></i>&nbsp;Add New</button> <br><br>
  
  <table class="table table-bordered table-striped table-hover" id="table-courses">
    
    <thead>
      <tr>
        <th>Mã Khóa Học</th>
        <th>Tên Khóa Học</th>
        <th>Học Phí</th>
        <th>Giảm Học Phí</th>
        <th>Thời hạn ĐK</th>
        <th>Action</th>
      </tr>
    </thead>
    <tbody>
    </tbody>
  </table>
</div>

<!-- Modal user infor-->
<div id="course-modal" class="modal fade" tabindex="-1">
  <div class="modal-dialog">
      <div class="modal-content">
          <div class="modal-header">
              <h5 class="modal-title">Course Detail</h5>
              <button type="button" class="close" data-dismiss="modal">&times;</button>
          </div>
          <!-- Modal body - chứa form dữ liệu -->
          <div class="modal-body"> 
              <form> <!-- form thiết kế như form bình thường, theo grid model -->
                <div class="row form-group">
                  <label class="col-sm-4 col-form-label">Mã Khóa Học</label>
                  <div class="col-sm-8">
                    <input class="form-control" id="input-modal-courseId">
                  </div>
                </div>

                <div class="row form-group">
                  <label class="col-sm-4 col-form-label">Tên Khóa Học</label>
                  <div class="col-sm-8">
                    <input class="form-control" id="input-modal-courseName">
                  </div>
                </div>

                <div class="row form-group">
                  <label class="col-sm-4 col-form-label">Học Phí</label>
                  <div class="col-sm-8">
                    <input class="form-control" id="input-modal-price">
                  </div>
                </div>

                <div class="row form-group">
                  <label class="col-sm-4 col-form-label">Giảm Học Phí</label>
                  <div class="col-sm-8">
                    <input class="form-control" id="input-modal-discountPrice">
                  </div>
                </div>

                <div class="row form-group">
                  <label class="col-sm-4 col-form-label">Hạn Chót</label>
                  <div class="col-sm-8">
                    <input class="form-control" id="input-modal-duration">
                  </div>
                </div>
              </form>
          </div>
          <div class="modal-footer">
              <button type="button" id="btn-modal-save" class="btn btn-primary" data-dismiss="modal">Save</button>
              <button type="button" id="btn-modal-close" class="btn btn-secondary" data-dismiss="modal">Close</button>
          </div>
      </div>
  </div>
</div>

<div id="new-course-modal" class="modal fade" tabindex="-1">
  <div class="modal-dialog">
      <div class="modal-content">
          <div class="modal-header">
              <h5 class="modal-title">New Course Info</h5>
              <button type="button" class="close" data-dismiss="modal">&times;</button>
          </div>
          <!-- Modal body - chứa form dữ liệu -->
          <div class="modal-body"> 
              <form> <!-- form thiết kế như form bình thường, theo grid model -->
                <div class="row form-group">
                  <label class="col-sm-4 col-form-label">Mã Khóa Học</label>
                  <div class="col-sm-8">
                    <input class="form-control" id="input-add-modal-courseId">
                  </div>
                </div>

                <div class="row form-group">
                  <label class="col-sm-4 col-form-label">Tên Khóa Học</label>
                  <div class="col-sm-8">
                    <input class="form-control" id="input-add-modal-courseName">
                  </div>
                </div>

                <div class="row form-group">
                  <label class="col-sm-4 col-form-label">Học Phí</label>
                  <div class="col-sm-8">
                    <input class="form-control" id="input-add-modal-price">
                  </div>
                </div>

                <div class="row form-group">
                  <label class="col-sm-4 col-form-label">Giảm Học Phí</label>
                  <div class="col-sm-8">
                    <input class="form-control" id="input-add-modal-discountPrice">
                  </div>
                </div>

                <div class="row form-group">
                  <label class="col-sm-4 col-form-label">Hạn Chót</label>
                  <div class="col-sm-8">
                    <input class="form-control" id="input-add-modal-duration">
                  </div>
                </div>
              </form>
          </div>
          <div class="modal-footer">
              <button type="button" id="btn-modal-add" class="btn btn-primary" data-dismiss="modal"><i class="fa-solid fa-plus"></i>Add</button>
              <button type="button" id="btn-modal-close" class="btn btn-secondary" data-dismiss="modal">Close</button>
          </div>
      </div>
  </div>
</div>
​
<div id="delete-course-modal" class="modal fade" tabindex="-1">
  <div class="modal-dialog">
      <div class="modal-content">
          <div class="modal-header">
              <h5 class="modal-title">Delete Course</h5>
          </div>
          <!-- Modal body - chứa form dữ liệu -->
          <div class="modal-body"> 
              <p> Are you sure want to delete This Course?  </p>
          </div>
          <div class="modal-footer clearfix">
            <button type="button" class="cancelbtn">Cancel</button>
            <button type="button" class="deletebtn">Delete</button>
          </div>
      </div>
  </div>
</div>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  

  // Biến mảng toàn cục chứa danh sách tên các thuộc tính
  const gCOURSES_COLS = ["id", "courseCode", "price", "discountPrice","duration", "action"];
  
  // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
  const gCOURSE_ID = 0;
  const gCOURSE_NAME = 1;
  const gCOURSE_PRICE = 2;
  const gCOURSE_DISCOUNT = 3;
  const gCOURSE_DURATION= 4
  const gCOURSE_ACTION = 5;

  
  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  // gắn sự kiện click cho các nút user detail
  $(document).ready(function(){
    callApiGetAllCourses();
    $(".course-add").on("click", function(){
      onBtnAddNewClick();
    } );
    
  });
  $(document).on("click",".course-delete", function(){
      onBtnDeleteClick(this);
    });

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  // hàm xử lý khi click vào nút Update
  function onCourseUpdateClick(paramUpdateBtn, paramCoursesTable) {
    // lấy được data của user
   
    var vTableRow = $(paramUpdateBtn).parents("tr");
    var vDataTableRow = paramCoursesTable.row(vTableRow);
    var  vCourseData= vDataTableRow.data();
    /***
     * TODO: xử lý tiếp đvCourseDataể show dữ liệu user lên Modal 
     */
    //hiển thị modal
    $("#course-modal").modal("show");
    //điền dữ liệu cho modal
    $("#input-modal-courseId").val(vCourseData.id);
    $("#input-modal-courseName").val(vCourseData.courseCode);
    $("#input-modal-price").val(vCourseData.price);
    $("#input-modal-discountPrice").val(vCourseData.discountPrice);
    $("#input-modal-duration").val(vCourseData.duration);
    
  }
  function onBtnAddNewClick(){
    $("#new-course-modal").modal("show");
  }
  function onBtnDeleteClick(paramDelButton){
    $("#delete-course-modal").modal("show");
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  function callApiGetAllCourses(){
    $.ajax({
          url: "https://624abe0dfd7e30c51c110ac6.mockapi.io/api/v1/"+"courses/",
          type: "GET",
          dataType: "json",
          success: function (resCourses) {
            console.log(resCourses);
            loadCoursesToTable(resCourses);
            
          },
          error: function (ajaxContext) {
            console.log(ajaxContext.responseText);
          },
        });
  }

  function loadCoursesToTable(paramResCourses){
    // Chuyển đổi html table thành DataTable và cấu hình cho DataTable
  var gCoursesTable = $("#table-courses").DataTable({
    data: paramResCourses,
    columns: [
      { data: gCOURSES_COLS[gCOURSE_ID] },
      { data: gCOURSES_COLS[gCOURSE_NAME] },
      { data: gCOURSES_COLS[gCOURSE_PRICE] },
      { data: gCOURSES_COLS[gCOURSE_DISCOUNT] },
      { data: gCOURSES_COLS[gCOURSE_DURATION] },
      { data: gCOURSES_COLS[gCOURSE_ACTION] }
    ],
    columnDefs: [
      {
        targets: gCOURSE_ACTION,
        defaultContent: `<button class='btn btn-primary course-update'><i class="fa-solid fa-pen-to-square"></i>Update</button>
        <button class='btn btn-danger course-delete'><i class="fa-solid fa-trash"></i>Delete</button>
        `
      }
    ]
  });
  $("#table-courses").on("click", ".course-update", function() {
    onCourseUpdateClick(this, gCoursesTable);
  });
  }
</script>
</body>
</html>
​
